/*
 * Book's Story — free and open-source Material You eBook reader.
 * Copyright (C) 2024-2026 Acclorite
 * SPDX-License-Identifier: GPL-3.0-only
 */

package org.dueattendant149.bookshelf.domain.use_case.history

import org.dueattendant149.bookshelf.core.log.logE
import org.dueattendant149.bookshelf.core.log.logI
import org.dueattendant149.bookshelf.domain.model.history.History
import org.dueattendant149.bookshelf.domain.repository.HistoryRepository
import javax.inject.Inject

private const val TAG = "GetHistoryForBook"

class GetHistoryForBookUseCase @Inject constructor(
    private val historyRepository: HistoryRepository
) {

    suspend operator fun invoke(bookId: Int): History? {
        logI(TAG, "Getting history for [$bookId].")

        return historyRepository.getHistoryForBook(bookId = bookId).fold(
            onSuccess = {
                logI(TAG, "Successfully got history for [$bookId].")
                it
            },
            onFailure = {
                logE(TAG, "Could not get history for [$bookId] with error: ${it.message}")
                null
            }
        )
    }
}